/*
 * This software is in the public domain.
 * You may use it as you see fit with the understanding that
 * we make no guarantees of its fitness for any particular purpose.
 *
 * Author: XESS Corporation
 *         www.xess.com
 */

// $Log: UTILS.CPP,v $
// Revision 1.2  2000/11/14 11:25:16  bretzdl
// Port to Linux. Makefile DLPORTIO.C added
//
// Revision 1.2  1999/03/30 18:27:12  DEVB
// Released source into the public domain
//
// Revision 1.1  1999/03/29 21:58:49  DEVB
// Initial revision
//

//
// Utility routines used by other programs.
//

#include <ctype.h>
#include <assert.h>
#include <string>
using std::string;


// begin methods and functions

// convert a string to upper case
string& ConvertToUpperCase(string& s)
{
	for(int i=0; i<s.length(); i++)
		s[i] = toupper(s[i]);
	return s;
}

// strip suffix from a file name
string& StripSuffix(string& fileName)
{
	assert(fileName.empty()==false);
	for(int i=fileName.length()-1; i>=0; i-- )
	{
		if(fileName[i]=='.') // found the last period that delimits the suffix
		{
			fileName.erase(i,fileName.length()-i); // cut off the suffix
			break;
		}
		else if(fileName[i]=='\\') // found the file/directory delimiter
			break;        //  so there is no suffix
	}
	return fileName;  // return the suffix-stripped file name
}

// get suffix from a file name
string GetSuffix(string& fileName)
{
	assert(fileName.empty()==false);
	for(int i=fileName.length()-1; i>=0; i--)
	{
		if(fileName[i]=='.') // found the last period that delimits the suffix
			return fileName.substr(i+1,fileName.length()-(i+1));
		else if(fileName[i]=='\\') // found the file/directory delimiter
			break;
	}
	return string(""); // no suffix. return empty string
}

// strip prefixed directory path from a file name
string& StripPrefix(string& fileName)
{
	assert(fileName.empty()==false);
	for(int i=fileName.length()-1; i>=0; i--)
		if(fileName[i]=='\\') // found the last file/directory delimiter
		{
			// return only the last part of the file name
			fileName = fileName.substr(i+1,fileName.length()-(i+1));
			return fileName;
		}
		return fileName;  // no prefix, so return the original file name
}

// get prefixed directory path from a file name
string GetPrefix(string& fileName)
{
  int i;
  assert(fileName.empty()==false);
  for(i=fileName.length()-1; i>=0; i--)
    if(fileName[i]=='\\') // found the last file/directory delimiter
      break;
  return fileName.substr(0,i);	// return the directory path without the file name
}

