// gxssetclkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gxssetclk.h"
#include "gxssetclkDlg.h"

#include "xc95.h"
#include "xc40.h"
#include "utils.h"
#include <time.h>
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGxssetclkDlg dialog

CGxssetclkDlg::CGxssetclkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGxssetclkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGxssetclkDlg)
	m_chkExtClk = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGxssetclkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGxssetclkDlg)
	DDX_Control(pDX, IDC_STATIC_STATUS, m_staticStatus);
	DDX_Control(pDX, IDC_EDIT_FREQ, m_editFreq);
	DDX_Control(pDX, IDC_CMB_LPT, m_cmbLpt);
	DDX_Control(pDX, IDC_CMB_BOARD, m_cmbBoard);
	DDX_Check(pDX, IDC_CHK_EXTCLK, m_chkExtClk);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGxssetclkDlg, CDialog)
	//{{AFX_MSG_MAP(CGxssetclkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_SET, OnSet)
	ON_BN_CLICKED(IDC_CHK_EXTCLK, OnChkExtclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGxssetclkDlg message handlers

BOOL CGxssetclkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_cmbBoard.SelectString(-1,"XS95-108");  // select the first board in the list
	m_cmbLpt.SelectString(-1,"LPT1");  // select the default parallel port upon startup
	m_staticStatus.SetWindowText("Set the XS Board clock frequency by entering a divisor for the 100 MHz master frequency");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGxssetclkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGxssetclkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGxssetclkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGxssetclkDlg::OnSet() 
{
	// TODO: Add your control notification handler code here

	// get the directory where the tools and RAM download files are kept
	char* xstoolsBinDir = getenv("XSTOOLS_BIN_DIR");
	if(xstoolsBinDir==NULL)
	{
		AfxMessageBox("The XSTOOLS_BIN_DIR environment file is not set!", MB_ICONSTOP);
		return;
	}

	// get oscillator frequency divisor from edit box
	char s[100];
	int sLen = m_editFreq.GetWindowText(s,100);
	if(sLen<=0)
	{
		AfxMessageBox("You must specify a numeric divisor for the 100 MHz master frequency", MB_ICONSTOP);
		return;
	}
	int divisor;
	if(sscanf(s,"%d",&divisor)!=1)
	{
		AfxMessageBox("You must specify a numeric divisor for the 100 MHz master frequency!", MB_ICONSTOP);
		return;
	}
	
	XSError errMsg(cerr); // setup error channel
	int portNum = m_cmbLpt.GetCurSel()+1;

	typedef enum{XS95,XS40,XSV} boardFamily;
	struct oscIntfc_struct
	{
		char* brdType;
		char* bitstreamFile;
		bool  isSVF;
		boardFamily brdFamily;
	} oscIntfc[] = 
	{
		{"XS95-108",  "OSC108.SVF",true,XS95},
		{"XS95-072",  "OSC072.SVF",true,XS95},
		{"XS40-005XL","OSC05XL.BIT",false,XS40},
		{"XS40-005E", "OSC05E.BIT",false,XS40},
		{"XS40-010XL","OSC10XL.BIT",false,XS40},
		{"XS40-010E", "OSC10E.BIT",false,XS40},
		{"XSP-010",   "OSCS10.BIT",false,XS40},

		{"XS95-108+",  "OSC108.SVF",true,XS95},
		{"XS95-072+",  "OSC072.SVF",true,XS95},
		{"XS40-005XL+","OSC05XL.BIT",false,XS40},
		{"XS40-005E+", "OSC05E.BIT",false,XS40},
		{"XS40-010XL+","OSC10XL.BIT",false,XS40},
		{"XS40-010E+", "OSC10E.BIT",false,XS40},
		{"XSP-010+",   "OSCS10.BIT",false,XS40},
		{"XSV",       "OSCXSV.SVF",true,XSV},
	};

	XCPort* portPtr;
	string bitFileName;
	int brdIndex,i;
	if((brdIndex = m_cmbBoard.GetCurSel()) != CB_ERR)
	{
		CString brdType;
		m_cmbBoard.GetLBText(brdIndex,brdType);
		for(i=sizeof(oscIntfc)/sizeof(oscIntfc_struct)-1; i>=0; i--)
			if(brdType==oscIntfc[i].brdType)
				break;
		if(oscIntfc[i].brdFamily==XS95 || oscIntfc[i].brdFamily==XSV)	// setting clock on XS95/XSV board
		{
			bitFileName = xstoolsBinDir;
			bitFileName += "\\";
			bitFileName += oscIntfc[i].bitstreamFile;
			portPtr = new XC95(&errMsg,portNum);
		}
		else if(oscIntfc[i].brdFamily==XS40)	// setting clock on an XS40 Board
		{
			bitFileName = xstoolsBinDir;
			bitFileName += "\\";
			bitFileName += oscIntfc[i].bitstreamFile;
			portPtr = new XC40(&errMsg,portNum,bitFileName,(string)xstoolsBinDir);
		}
		else
		{
			assert(1==0);	// should never get here
		}
	}
	XCPort& port = *portPtr;

	string instructions;
	if(oscIntfc[i].brdFamily==XS95)
	{
		instructions = "Before setting the XS95 Board frequency you must:\n";
		instructions += "1) Remove the power and downloading cable from your XS95 Board\n";
		instructions += "2) Place a shunt on the \"set\" position of jumper J6\n";
		instructions += "3) Reconnect the downloading cable\n";
		instructions += "4) Reconnect the power cable\n";
		instructions += "5) Click on the OK button";
	}
	else if(oscIntfc[i].brdFamily==XS40)
	{
		instructions = "Before setting the XS40 Board frequency you must:\n";
		instructions += "1) Remove the power and downloading cable from your XS40 Board\n";
		instructions += "2) Place a shunt on the \"set\" position of jumper J12\n";
		instructions += "3) Reconnect the downloading cable\n";
		instructions += "4) Reconnect the power cable\n";
		instructions += "5) Click on the OK button";
	}
	else if(oscIntfc[i].brdFamily==XSV)
	{
		instructions = "Before setting the XSV Board frequency you must:\n";
		instructions += "1) Turn off the power to your XSV Board\n";
		instructions += "2) Place a shunt across pins 1 and 2 of both jumpers J22 and J36\n";
		instructions += "3) Turn on the power to your XSV Board\n";
		instructions += "4) Click on the OK button";
	}
	else
	{
		assert(1==0);	// should never get here
	}
	if(AfxMessageBox(instructions.data(),MB_ICONINFORMATION | MB_OKCANCEL) == IDCANCEL)
	{
		m_staticStatus.SetWindowText("");
		delete portPtr;
		return;
	}

	string msg;
	msg = (oscIntfc[i].isSVF) ? "Downloading clock-set bitstream to CPLD...":"Downloading clock-set bitstream to FPGA...";
	m_staticStatus.SetWindowText(msg.data());

	port.ConfigureFPLD(bitFileName);
	if(errMsg.IsError())
	{
		AfxMessageBox("Error downloading clock-set circuit!!",MB_ICONSTOP);
		m_staticStatus.SetWindowText("");
		delete portPtr;
		return;
	}

	m_staticStatus.SetWindowText("Setting frequency...");

	port.SetOscFrequency(divisor,m_chkExtClk ? 1:0);	

	m_staticStatus.SetWindowText("");

	if(oscIntfc[i].brdFamily==XS95)
	{
		instructions = "The frequency of your XS95 Board has been set!!\n";
		instructions += "Now do these steps to activate the oscillator:\n";
		instructions += "1) Remove the power and downloading cable from your XS95 Board\n";
		instructions += "2) Move the shunt to the \"osc\" position of jumper J6\n";
		instructions += "3) Reconnect the power cable\n";
		instructions += "4) Reconnect the downloading cable\n";
		instructions += "5) Click on the OK button";
	}
	else if(oscIntfc[i].brdFamily==XS40)
	{
		instructions = "The frequency of your XS40 Board has been set!!\n";
		instructions += "Now do these steps to activate the oscillator:\n";
		instructions += "1) Remove the power and downloading cable from your XS40 Board\n";
		instructions += "2) Move the shunt to the \"osc\" position of jumper J12\n";
		instructions += "3) Reconnect the power cable\n";
		instructions += "4) Reconnect the downloading cable\n";
		instructions += "5) Click on the OK button";
	}
	else if(oscIntfc[i].brdFamily==XSV)
	{
		instructions = "The frequency of your XSV Board has been set!!\n";
		instructions += "Now do these steps to activate the oscillator:\n";
		instructions += "1) Turn off the power to your XSV Board\n";
		instructions += "2) Move the shunt to pins 2 and 3 of jumper J22\n";
		instructions += "3) Leave the shunt across pins 1 and 2 of jumper J36\n";
		instructions += "4) Turn on the power to your XSV Board\n";
		instructions += "5) Click on the OK button\n\n";
		instructions += "YOU MUST REPROGRAM THE CPLD INTERFACE TO YOUR XSV BOARD!!";
	}
	else
	{
		assert(1==0);	// should never get here
	}

	AfxMessageBox(instructions.data(),MB_ICONINFORMATION);

	delete portPtr;
}

void CGxssetclkDlg::OnChkExtclk() 
{
	// TODO: Add your control notification handler code here
	m_chkExtClk = (m_chkExtClk==TRUE) ? FALSE:TRUE;	
}
