$MOD51
$TITLE(epX31 Hardware Tester)

YES             EQU     1
NO              EQU     0

CR              EQU     0DH
LF              EQU     0AH
ESC             EQU     1BH

STACKTOP EQU    70H    ; start of stack (grows up)
LEDLATCH EQU    0FFFFH ; LED latch address

OKLED           EQU     01110111B       ; code for 'O'
ERRORLED        EQU     01101101B       ; code for 'E'
HEARTBEAT		EQU		P3.1			; INFORMS PC WE ARE ALIVE
MEMORYEND		EQU		080H			; FIRST NONEXISTENT RAM LOCATION


        DSEG AT 031H
RNDINDX:        DS      1
ERRFLAG:        DS      1
PROGRESS:       DS      1

        CSEG
        ORG     0H

START:
        MOV     IE,#0
        MOV     SP,#STACKTOP
        MOV     PROGRESS,#1
        MOV     A,PROGRESS
        CALL    SHOWLED
        MOV     RNDINDX,#(RNDNUMTBLSIZE-1)
        MOV     DPTR,#MEMORYSTART
LOAD_MEM:
        CALL    RNG
        MOVX    @DPTR,A
        INC     DPTR
        MOV     A,DPL
        JNZ     LOAD_MEM
		CPL		HEARTBEAT
        MOV     A,PROGRESS
        RL      A
        MOV     PROGRESS,A
        CALL    SHOWLED
        MOV     A,DPH
        CJNE    A,#MEMORYEND,LOAD_MEM         

        MOV     ERRFLAG,#NO
        MOV     RNDINDX,#(RNDNUMTBLSIZE-1)
        MOV     DPTR,#MEMORYSTART
CHECK_MEM:
        CALL    RNG
        MOV     B,ACC
        MOVX    A,@DPTR
        CLR     C
        SUBB    A,B
        JZ      CHECK_MEM1
        MOV     ERRFLAG,#YES
CHECK_MEM1:
        INC     DPTR
        MOV     A,DPL
        JNZ     CHECK_MEM
		CPL		HEARTBEAT
        MOV     A,DPH
        CJNE    A,#MEMORYEND,CHECK_MEM        

        MOV     A,ERRFLAG
        JZ      MEM_OK     
        MOV     A,#ERRORLED
        CALL    SHOWLED
        JMP     $
MEM_OK:
        MOV     A,#OKLED
        CALL    SHOWLED
MEM_OK1:
		CPL		HEARTBEAT		; OK - OUTPUT RAPID HEARTBEAT
        JMP		MEM_OK1     

RNDNUMTBL:      DB      206,49,186,72,103,129,202,230,
                DB      54,100,161,236,56,63,164,176,20
RNDNUMTBLSIZE   EQU     $-RNDNUMTBL

RNG:
        PUSH    DPH
        PUSH    DPL
        MOV     DPTR,#RNDNUMTBL
        MOV     A,RNDINDX
        MOVC    A,@A+DPTR
        DJNZ    RNDINDX,RNG1
        MOV     RNDINDX,#(RNDNUMTBLSIZE-1)
RNG1:        
        POP     DPL
        POP     DPH
        RET

SHOWLED:
        PUSH    DPH
        PUSH    DPL
        MOV     DPTR,#LEDLATCH
        MOVX    @DPTR,A
        POP     DPL
        POP     DPH
        RET
        NOP
        NOP

MEMORYSTART     EQU     0100H


        END
